static char *rcsid = "$Id: vmwdtect.cpp,v 1.1.1.1 2006/10/29 19:45:03 cvs Exp $";
/*
*
* $RCSfile: vmwdtect.cpp,v $
* $Source: /cvs/vmdet/vmwdtect.cpp,v $
* $Author: cvs $
* $Revision: 1.1.1.1 $
* $Date: 2006/10/29 19:45:03 $
* $State: Exp $
* Copyright (c) Stefan Kuhr
*
*
*
* $Log: vmwdtect.cpp,v $
* Revision 1.1.1.1  2006/10/29 19:45:03  cvs
* no message
* 
*/

/// 
/// original code written by lallous:
/// 
/* ----------------------------------------------------------------------------- 
 * Created by * lallous <lallousx86@yahoo.com> *
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * -----------------------------------------------------------------------------
 */ 


#include "vmwdtect.h"

extern "C" DWORD __cdecl TestVMWare(PDWORD );


BOOL IsRunningInVMWare(PDWORD pdwPlatform)
{
  DWORD dwSuccess = 0L;
  DWORD dwPlatform = 0;
  __try
  {
	  dwSuccess = TestVMWare(&dwPlatform);
  }
  __except(EXCEPTION_EXECUTE_HANDLER)
  {
	  dwSuccess = 0L;
  }

  if(dwSuccess)
  {
	  if(dwPlatform==0 || dwPlatform>VMWARE_VERSION_WKSTA)
		  dwPlatform = VMWARE_VERSION_UNKNOWN;
	  
	  if(pdwPlatform)
		  *pdwPlatform = dwPlatform;
	  return TRUE;	
  }

  return FALSE;		
}

#if _MSC_VER <= 1400 && !defined (_WIN64)

extern "C" DWORD __cdecl TestVMWare(PDWORD pdwPlatform)
{
  DWORD dwResult = 0;
__asm
  {
      push   edx
      push   ecx
      push   ebx

      mov    eax, 'VMXh'
      mov    ebx, 0 ; any value but not the MAGIC VALUE
      mov    ecx, 10 ; get VMWare version
      mov    edx, 'VX' ; port number

      in     eax, dx ; read port, on return EAX always returns 6
      mov    eax, 0
      cmp    ebx, 'VMXh' ; is it a reply from VMWare?
      jnz fail;
      mov edx, pdwPlatform; 
      mov dword ptr[edx], ECX ; write the VMWare Platform to the pdwPlatform out param
      mov    eax, 1

fail:
      pop    ebx
      pop    ecx
      pop    edx
      mov dwResult, eax;
  }

  return dwResult;  
}

#endif