static char *rcsid = "$Id: vpcdtect.cpp,v 1.1.1.1 2006/10/29 19:45:03 cvs Exp $";
/*
*
* $RCSfile: vpcdtect.cpp,v $
* $Source: /cvs/vmdet/vpcdtect.cpp,v $
* $Author: cvs $
* $Revision: 1.1.1.1 $
* $Date: 2006/10/29 19:45:03 $
* $State: Exp $
* Copyright (c) Stefan Kuhr
*
*
*
* $Log: vpcdtect.cpp,v $
* Revision 1.1.1.1  2006/10/29 19:45:03  cvs
* no message
* 
*/

/// 
/// 
/// original code written by lallous:
/// 
/* ----------------------------------------------------------------------------- 
 * Created by * lallous <lallousx86@yahoo.com> *
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ----------------------------------------------------------------------------- 
 */ 


#include "vpcdtect.h"

#ifndef _WIN64


// IsRunningInVirtualPC's exception filter
static LONG __forceinline IsRunningInVirtualPC_exceptionFilter(LPEXCEPTION_POINTERS ep)
{
  PCONTEXT ctx = ep->ContextRecord;

  ctx->Ebx = (DWORD)-1; // Not running VPC
  ctx->Eip += 4; // skip past the "call VPC" opcodes
  return EXCEPTION_CONTINUE_EXECUTION; // we can safely resume execution since we skipped faulty instruction
}


#endif /// _WIN64


BOOL IsRunningInVirtualPC(void)
{
#ifdef _WIN64
  
  /// 
  /// there is no x64 guest OS possible on Virtual PC up to and including
  /// Virtual PC 2007:
  /// 
  return FALSE;
#else /// _WIN64

 unsigned char ucResult = 0;

  __try
  {
    _asm 
    {
      push ebx
      mov  ebx, 0 // Flag
      mov  eax, 1 // VPC function number

      // call VPC 
      __emit 0Fh
      __emit 3Fh
      __emit 07h
      __emit 0Bh

      test ebx, ebx
      setz [ucResult]
      pop ebx
    }
  }
  // The except block shouldn't get triggered if VPC is running!!
  __except(IsRunningInVirtualPC_exceptionFilter(GetExceptionInformation()))
  {
  }

  return ucResult ? TRUE : FALSE;
#endif /// _WIN64
}
